osg::CompositeShape Class Reference

`#include <Shape>`

Inheritance diagram for osg::CompositeShape:

## Public Types

typedef std::vector< ref_ptr< Shape > > | ChildList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| CompositeShape ()
| CompositeShape (const CompositeShape &cs, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
| META_Shape (osg, CompositeShape)
void | setShape (Shape *shape)
Shape * | getShape ()
const Shape * | getShape () const
unsigned int | getNumChildren () const
Shape * | getChild (unsigned int i)
const Shape * | getChild (unsigned int i) const
void | addChild (Shape *shape)
template<class T>
void | addChild (const ref_ptr< T > &child)
void | removeChild (unsigned int i)
unsigned int | findChildNo (Shape *shape) const
Public Member Functions inherited from osg::Shape
| Shape ()
| Shape (const Shape &sa, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual void | accept (ShapeVisitor &)=0
virtual void | accept (ConstShapeVisitor &) const =0
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~CompositeShape ()
Protected Member Functions inherited from osg::Shape
virtual | ~Shape ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

ref_ptr< Shape > | _shape
ChildList | _children
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Deprecated.

## Member Typedef Documentation

## ChildList

typedef std::vector< ref_ptr<Shape> > osg::CompositeShape::ChildList

## Constructor & Destructor Documentation

## CompositeShape() [1/2]

osg::CompositeShape::CompositeShape | ( |  | ) |

inline

Referenced by CompositeShape(), and META_Shape().

## CompositeShape() [2/2]

osg::CompositeShape::CompositeShape | ( | const CompositeShape & | cs,
|  | const CopyOp & | copyop = CopyOp::SHALLOW_COPY )

inline

References _children, CompositeShape(), osg::CopyOp::SHALLOW_COPY, and osg::Shape::Shape().

## ~CompositeShape()

virtual osg::CompositeShape::~CompositeShape | ( |  | ) |

protected virtual

## Member Function Documentation

## addChild() [1/2]

template<class T>

void osg::CompositeShape::addChild | ( | const ref_ptr< T > & | child | ) |

inline

References addChild(), and osg::ref_ptr< T >::get().

Referenced by addChild().

## addChild() [2/2]

void osg::CompositeShape::addChild | ( | Shape * | shape | ) |

inline

Add a child to the list.

References _children, and osg::Shape::Shape().

## findChildNo()

unsigned int osg::CompositeShape::findChildNo | ( | Shape * | shape | ) | const

inline

find the index number of child, if child is not found then it returns getNumChildren(), so should be used in similar style to STL's result!=end().

References _children, and osg::Shape::Shape().

## getChild() [1/2]

Shape * osg::CompositeShape::getChild | ( | unsigned int | i | ) |

inline

Get a child.

References _children, and osg::Shape::Shape().

## getChild() [2/2]

const Shape * osg::CompositeShape::getChild | ( | unsigned int | i | ) | const

inline

Get a const child.

References _children, and osg::Shape::Shape().

## getNumChildren()

unsigned int osg::CompositeShape::getNumChildren | ( |  | ) | const

inline

Get the number of children of this composite shape.

References _children.

## getShape() [1/2]

Shape * osg::CompositeShape::getShape | ( |  | ) |

inline

Get the shape that encloses all of the children.

References _shape, and osg::Shape::Shape().

## getShape() [2/2]

const Shape * osg::CompositeShape::getShape | ( |  | ) | const

inline

Get the const shape that encloses all of the children.

References _shape, and osg::Shape::Shape().

## META_Shape()

osg::CompositeShape::META_Shape | ( | osg | ,
|  | CompositeShape | )

References CompositeShape().

## removeChild()

void osg::CompositeShape::removeChild | ( | unsigned int | i | ) |

inline

remove a child from the list.

References _children.

## setShape()

void osg::CompositeShape::setShape | ( | Shape * | shape | ) |

inline

Set the shape that encloses all of the children.

References _shape, and osg::Shape::Shape().

## Member Data Documentation

## _children

ChildList osg::CompositeShape::_children

protected

Referenced by addChild(), CompositeShape(), findChildNo(), getChild(), getChild(), getNumChildren(), and removeChild().

## _shape

ref_ptr<Shape> osg::CompositeShape::_shape

protected

Referenced by getShape(), getShape(), and setShape().

The documentation for this class was generated from the following file:

- Shape